[FFE] Need API to set urgency from background process

Reported by Rodney Dawes on 2011-04-01
10
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Ayatana Design
Medium
John Lea
Ubuntu One Client
High
Eric Casteleijn
Ubuntu One Control Panel
High
Eric Casteleijn
Unity
High
Jason Smith
Unity Foundations
High
Jason Smith
libunity
High
Jason Smith
unity-2d
High
Unassigned
libunity (Ubuntu)
High
Jason Smith
ubuntuone-client (Ubuntu)
High
Eric Casteleijn
ubuntuone-control-panel (Ubuntu)
High
Natalia Bidart
unity (Ubuntu)
High
Jason Smith

Bug Description

We need to be able to set a launcher on the panel as urgent in some cases, from a background process which has no open windows or UI, such as ubuntuone-syncdaemon. Currently the only way to do this is to start the ubuntuone-control-panel-gtk application and then set its window to urgent, which is rather intrusive and annoying. It would be much better to just set the launcher as urgent instead, so the user can click on the icon to open the control panel when they decide to.

This bug is tied deeply together with bug #747311 "Launcher - Remove the capability for Launcher icons to be overlaid with emblems" and for FFE they should be reviewed together.

Jason Smith (jassmith) on 2011-04-01
Changed in ubuntuone-client:
status: New → Confirmed
Changed in libunity:
assignee: nobody → Jason Smith (jassmith)
status: New → Confirmed
Rodney Dawes (dobey) on 2011-04-01
summary: - Need API to set urgency from background process
+ [FFE] Need API to set urgency from background process
Jason Smith (jassmith) on 2011-04-01
Changed in unity:
assignee: nobody → Jason Smith (jassmith)
status: New → Confirmed
Rodney Dawes (dobey) wrote :

This will require feature freeze exceptions for the related packages so that we can shi the API in 11.04 and use it.

Jason Smith (jassmith) on 2011-04-01
Changed in libunity (Ubuntu):
assignee: nobody → Jason Smith (jassmith)
importance: Undecided → High
status: New → Confirmed
Changed in ubuntuone-client (Ubuntu):
assignee: nobody → Jason Smith (jassmith)
importance: Undecided → High
status: New → Confirmed
Changed in unity (Ubuntu):
assignee: nobody → Jason Smith (jassmith)
importance: Undecided → High
status: New → Confirmed
Changed in unity:
importance: Undecided → High
milestone: none → 3.8.4
Changed in libunity:
importance: Undecided → High
Rodney Dawes (dobey) on 2011-04-01
Changed in ubuntuone-client:
assignee: nobody → Eric Casteleijn (thisfred)
Jason Smith (jassmith) on 2011-04-01
Changed in ubuntuone-client (Ubuntu):
assignee: Jason Smith (jassmith) → nobody
Changed in ubuntuone-client (Ubuntu):
assignee: nobody → Eric Casteleijn (thisfred)
Mark Shuttleworth (sabdfl) wrote :

Please look kindly on the FFE, requested by U1 but a useful extension for third-party app developers.

David Barth (dbarth) wrote :

I'm concerned about creating an API at the last minute, without time to review the rest of the problem space. The emblem API that is re-discussed in parallel, shows that APIs and design guidelines need to go together or else we risk making even more last minute changes.

I'd rather provide a non-documented, use-at-your-own-risk-if-your-not-U1, API for this release. And promote the API to public status for O, once all the ramifications of this case are well understood. The case in question is the one of service-oriented applications that lack permanent windows. The underlying infrastructure (bamf, launcher, libunity) is still heavily based on the assumption that an application has an open window.

John Lea (johnlea) on 2011-04-04
tags: added: udt
Changed in ayatana-design:
assignee: nobody → John Lea (johnlea)
status: New → Fix Released
importance: Undecided → Medium
Changed in ubuntuone-client:
status: Confirmed → In Progress

Since it's not explicit in this report: A part of the FFE is also to remove the emblem API from libunity (thus an AB+API break). Which I guess puts David's comment #3 into better context :-)

Changed in unity-2d:
status: New → Confirmed
importance: Undecided → High
Changed in unity-foundations:
assignee: nobody → Jason Smith (jassmith)
importance: Undecided → High
milestone: none → unity-3.8.4
status: New → Confirmed
description: updated
David Barth (dbarth) on 2011-04-04
tags: added: ffe
David Barth (dbarth) wrote :

Hereby requesting a Feature Freeze Exception.

The rationale for the change is that:
- the extra emblem properties (the API part that has to be removed) where not backed by a design case; on the contrary, Design confirms, after the experimentation phase, that the feature is not welcome: it would create more harm than good
- we're removing an API that only the U1 client was really using, and they're working on a fallback solution with Design
- it's the last time we can really pull this out; if released, we would have to support it for at least 18 months, and it's always difficult and long to deprecate an API

The code changes are referenced in the attached merge proposals. This FFE covers both:
- the removal of arbitrary emblems support
- the addition of the urgency API
- the related U1 changes

Changed in ubuntuone-client:
importance: Undecided → High
Changed in ubuntuone-control-panel:
importance: Undecided → High
status: New → In Progress
Changed in unity-2d:
milestone: none → 3.10
David Barth (dbarth) wrote :

Setting to new, to re-trigger the exception process.

Changed in libunity:
status: Confirmed → New
Changed in libunity (Ubuntu):
status: Confirmed → New
Changed in unity (Ubuntu):
status: Confirmed → New
Martin Pitt (pitti) wrote :

The patches are relatively unintrusive and rather clear, and add a lot of test cases. This looks ok to me, so approved.

Changed in unity (Ubuntu):
status: New → Confirmed
Changed in libunity (Ubuntu):
status: New → Confirmed
Changed in libunity:
status: New → Confirmed
Changed in ubuntuone-control-panel (Ubuntu):
assignee: nobody → Eric Casteleijn (thisfred)
status: New → Confirmed
importance: Undecided → High
Changed in ubuntuone-control-panel:
assignee: nobody → Eric Casteleijn (thisfred)
Changed in libunity:
milestone: none → 3.8.4
Changed in unity-foundations:
status: Confirmed → Fix Released
Changed in libunity:
status: Confirmed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libunity - 3.8.4-0ubuntu1

---------------
libunity (3.8.4-0ubuntu1) natty; urgency=low

  * New upstream release.
    - [FFE] Need API to set urgency from background process (LP: #747677)
    - Launcher - Remove the capability for Launcher icons to be overlaid with
      emblems (LP: #747311)
    - When we press Enter to run the first search result, Unity should wait
      until searching is finished (LP: #749428)
  * debian/libunity3.install => debian/libunity4.install
    debian/libunity3.symbols => debian/libunity4.symbols
    debian/control, debian/libunity4.symbols:
    - handle abi break and soname bump
    - replaces libunity3 for the gir file
 -- Didier Roche <email address hidden> Thu, 07 Apr 2011 13:05:26 +0200

Changed in libunity (Ubuntu):
status: Confirmed → Fix Released
Didier Roche (didrocks) on 2011-04-07
Changed in unity:
milestone: 3.8.4 → 3.8.6
Changed in ubuntuone-client:
status: In Progress → Fix Committed
Changed in ubuntuone-control-panel:
status: In Progress → Fix Committed
Changed in ubuntuone-control-panel:
status: Fix Committed → Fix Released
Changed in ubuntuone-control-panel (Ubuntu):
assignee: Eric Casteleijn (thisfred) → Naty Bidart (nataliabidart)
status: Confirmed → In Progress
Jason Smith (jassmith) on 2011-04-08
Changed in unity:
status: Confirmed → Fix Committed
Changed in unity (Ubuntu):
status: Confirmed → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubuntuone-control-panel - 0.9.5-0ubuntu1

---------------
ubuntuone-control-panel (0.9.5-0ubuntu1) natty; urgency=low

  * New upstream release:

    [ <email address hidden> ]
      - Now that we set the launcher urgency from ubuntuone-client, the control
      panel needs to remove it when its window receives focus (LP: #747677).
      - changed default value for switch_to to empty string, and now don't call
      switch_to method when the value is empty string (or anything else falsy)
      (LP: #752943).
      - Added proper defaults to the command line arguments (LP: #746489).
      - Fixed issue where closing the panel resulted in a runtime error
      (LP: #745987).
      - This adds a method to the dbus service that allows switching between
      panels, and/or drawing attention to the control panel (LP: #742008).
      - Removed the shortcut group that causes two Ubuntu One entries to appear
      in the messaging menu when syncdaemon is not running (LP: #721525).
    [ Natalia B. Bidart <email address hidden> ]
      - If servers reply with a 401, clear credentials and ask user to
      authenticate (LP: #726612).
      - Moving style_check down so the exit code from u1trial is not hidden by
      && operator.
      - Unify disable/enable file sync functionality among Services tab and
      global file sync status (LP: #729301).
      - Cloud Folders tab is now disabled when the file sync service is
      (LP: #747482).
      - Improving legend for plugin installation to ease translations
      (LP: #746374).
      - Added volumes.ui to the translation list (LP: #746370).
      - Small improvement to show something else besides the generic "Value can
      not be retrieved." error (LP: #722485).
      - Made the backend robust against possible None values (or any non
      basestring instance) sent from the API server (LP: #745790).
      - Decoupled device list retrieved from the web from the local settings
      retrieved from syncdaemon (LP: #720704).
      - Stop the control panel backend once the UI is done
      (LP: #704434).
      - After initial computer adding, syncdameon is asked to connect
      (LP: #715873).
 -- Natalia Bidart (nessita) <email address hidden> Fri, 08 Apr 2011 15:53:02 -0300

Changed in ubuntuone-control-panel (Ubuntu):
status: In Progress → Fix Released
Rodney Dawes (dobey) on 2011-04-11
Changed in ubuntuone-client:
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubuntuone-client - 1.6.0-0ubuntu1

---------------
ubuntuone-client (1.6.0-0ubuntu1) natty; urgency=low

  * New upstream release.
    - Avoid conflict when same file already exists locally (LP: #711389)
    - Must move fils to trash on deletion (LP: #690673)
    - Support disconnection during initial connect attempt (LP: #711211)
    - Log version number on startup (LP: #715455)
    - Memory usage too high (LP: #721483)
    - Unsubscribed folders show as synced, if they exist (LP: #741835)
    - gnome-settings-daemon crash in g_str_hash (LP: #744383)
    - Should not re-queue uploads directly (LP: #744608)
    - No feedback when creating folder from symlink fails (LP: #747299)
    - [FFE] Use API to set urgency from background process (LP: #747677)
    - Open control panel to volumes when quota exceeded (LP: #702176)
    - Set the launcher to urgent when quota exceeded (LP: #702183)
    - nautilus crash in g_str_hash (LP: #724882)
    - Disable/enable file sync is buggy (LP: #744980)

  [Chris Coulson]
  * gnome-settings-daemon crash in g_return_fail_if_warning (LP: #744980)
 -- Rodney Dawes <email address hidden> Sun, 10 Apr 2011 21:24:30 -0400

Changed in ubuntuone-client (Ubuntu):
status: Confirmed → Fix Released
Didier Roche (didrocks) on 2011-04-11
Changed in unity:
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package unity - 3.8.6-0ubuntu1

---------------
unity (3.8.6-0ubuntu1) natty; urgency=low

  * New upstream release.
    - compiz crashed with SIGABRT in raise() (LP: #748163)
    - System freezes when maximize button is clicked (LP: #754063)
    - compiz crashed with SIGSEGV in QuicklistView::IsMenuItemSeperator()
      (LP: #754302)
    - compiz crashed with SIGSEGV in std::_List_node_base::_M_hook()
      (LP: #754235)
    - compiz crashed with SIGSEGV in ubus_server_pump_message_queue()
      (LP: #754657)
    - drag from dash to launcher (LP: #662616)
    - Add a test case for unity-decorator regressions (LP: #736878)
    - the files place category combo has empty space (LP: #741641)
    - panel superposition (LP: #742859)
    - Unity Launcher stops autohiding and is not responsive (LP: #744325)
    - Unity Launcher stops autohiding and is not responsive (LP: #744325)
    - [FFE] Need API to set urgency from background process (LP: #747677)
    - Launcher - Escape from 'drag behind the Launcher' interaction
      (LP: #750298)
    - Launcher needs to be desaturated when Dash is open, not transparent.
      (LP: #750358)
    - compiz crashed with SIGSEGV in free() (LP: #752293)
    - migrate_favorites.py crashed with ImportError in __main__: No module
      named gconf (LP: #752176)
    - compiz crashed with SIGSEGV in PluginClassHandler<DecorWindow,
      CompWindow, 0>::get() (LP: #743807)
    - cannot close the dash by clicking on the bfb (LP: #753914)
    - Animation for Grid Previews is broken (LP: #754088)
    - compiz crashed with SIGSEGV in PanelMenuView::OnPlaceViewShown()
      (LP: #754585)
    - Pressing F10 then "left arrow" wit Unity on Natty makes the system
      unusable (LP: #756867)
    - compiz crashed with SIGSEGV in __pthread_mutex_lock() (LP: #711231)
    - Tooltips and Dash Font Problems (LP: #741605)
    - Title elipisising incorrect. Type “Shotwell” for a good example
      (LP: #750350)
    - compiz crashed with SIGSEGV in Launcher::Launcher() (LP: #748096)
    - BFB - Turn top left corner blue rather than Ubuntu logo (LP: #755286)
    - launcher appears and gets stuck when resizing windows with mouse
      (LP: #754690)
    - Wrong item gets dragged out (LP: #729796)
    - Launcher - when the launcher is folded, the bottom icon partially falls
      off the end of the screen (LP: #731869)
    - unity-window-decorator: Resize padding: Tiny focused windows lose resize
      padding and shadow when <69 pixels wide (LP: #737707)
    - Deinstalling an application with launcher entry leaves orphaned shortcut
      (LP: #748107)
    - Two Nautilus windows open when clicked on a device icon on Launcher
      (started after 3.8.2) (LP: #748299)
    - compiz crashed with SIGSEGV in Launcher::AnimationTimeout()
      (LP: #749890)
  * debian/control:
    - build-dep on latest nux (ABI break)
  * debian/unity-common.install:
    - install the desktop file for the new capplet
 -- Didier Roche <email address hidden> Mon, 11 Apr 2011 12:42:33 +0200

Changed in unity (Ubuntu):
status: Fix Committed → Fix Released
tags: added: delta-with-3d
John Lea (johnlea) on 2011-04-18
tags: added: reviewedbydesign
removed: udt
Changed in unity-2d:
milestone: 3.10 → none
no longer affects: libunity (Ubuntu Quantal)
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers